﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DateTimePickerWithMilliseconds
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

            var culture = new CultureInfo("en-US");
            var dtfInfo = new DateTimeFormatInfo
            {
                ShortDatePattern = "dd.MM.yyy",
                ShortTimePattern = "HH:mm:ss.fff"
            };
            culture.DateTimeFormat = dtfInfo;
            this.RadDateTimePicker.Culture = culture;
		}

		private void RadDateTimePicker_ParseDateTimeValue(object sender, Telerik.Windows.Controls.ParseDateTimeEventArgs args)
		{
			string input = args.TextToParse;
			var dateTimeNow = DateTime.Today;
			int month = dateTimeNow.Month;
			int day = dateTimeNow.Day;
			int year = dateTimeNow.Year;
			int hour = dateTimeNow.Hour;
			int minute = dateTimeNow.Minute;
			int second = dateTimeNow.Second;
			int millisecond = dateTimeNow.Millisecond;
			if (input.Length >= 2)
			{
				int dayInput;
				int.TryParse(input.Substring(0, 2), out dayInput);
				if (dayInput != 0)
				{
					day = dayInput;
				}
			}
			if (input.Length >= 5)
			{
				int monthInput;
				int.TryParse(input.Substring(3, 2), out monthInput);
				if (monthInput != 0)
				{
					month = monthInput;
				}
			}
			if (input.Length >= 10)
			{
				int yearInput;
				int.TryParse(input.Substring(6, 4), out yearInput);
				if (yearInput != 0)
				{
					year = yearInput;
				}
			}
			if (input.Length >= 13)
			{
				int hourInput;
				int.TryParse(input.Substring(11, 2), out hourInput);
				if (hourInput != 0)
				{
					hour = hourInput;
				}
			}
			if (input.Length >= 16)
			{
				int minuteInput;
				int.TryParse(input.Substring(14, 2), out minuteInput);
				if (minuteInput != 0)
				{
					minute = minuteInput;
				}
			} 
			if (input.Length >= 19)
			{
				int secondInput;
				int.TryParse(input.Substring(17, 2), out secondInput);
				if (secondInput != 0)
				{
					second = secondInput;
				}
			}
			if (input.Length >= 23)
			{
				int millisecondInput;
				int.TryParse(input.Substring(20, 3), out millisecondInput);
				if (millisecondInput != 0)
				{
					millisecond = millisecondInput;
				}
			}

			args.Result = new DateTime(year, month, day, hour, minute, second, millisecond);

			args.IsParsingSuccessful = true;
		}
	}
}
